//
// forms
//

// Notes
// [1] focus-highlighting on inputs was cut off by overflow: hidden
// [2] reset for FF and Chrome, coming with a min-width
// [3] force IE8 to wrap long content
// [4] reate half-transparent borders (otherwise you have a half-transparent border using the input background color)
// [5] reset height
// [6] disable mobile safari make it a search field with different border-radius and size
// [7] reset unusual Firefox-on-Android default style
// [8] ie10 padding-bottom bug

// Variables
$input-border-width: $base-border-width !default;
$input-border-radius: $base-border-radius !default;
$input-border-color: $color-gray-light !default;

.ce_form {
  overflow: visible;
}

fieldset {
  padding: 0;
  margin: 0;
  border: 0;
  min-width: 0; // [2]
}

label {
  display: inline-block;
  max-width: 100%; // [3]
  margin-bottom: $base-spacing-unit-sm;
  font-weight: 700;
}

input.captcha,
input.text,
textarea {
  display: block;
  width: 100%;
  padding: $base-spacing-unit-sm;
  border-radius: $input-border-radius;
  border: $input-border-width solid $input-border-color;
  background-clip: padding-box; // [4]
  background-image: none; // [7]
}

textarea.textarea {
  height: auto; // [5]
  resize: vertical;
  vertical-align: top;
}

.widget-explanation,
.widget-password,
.widget-text,
.widget-textarea {
  margin-bottom: $base-spacing-unit;
}

button.submit,
input.submit {
  @extend .button;
  @extend .button-highlighted;
  margin-top: $base-spacing-unit;
}

input[type="search"] {
  -webkit-appearance: none; // [6]
}

// Checkboxes and radios
input.checkbox,
input.radio {
  line-height: normal;

  + label {
    font-weight: normal;
    margin: 0 $base-spacing-unit 0 $base-spacing-unit-sm;
  }
}

select.select {
  margin-left: $base-spacing-unit-sm;
  // modification
  -webkit-appearance: none;
  background: none;
  background-clip: padding-box; // [4]
  padding: $base-spacing-unit-sm $base-spacing-unit + $base-spacing-unit-sm $base-spacing-unit-sm $base-spacing-unit-sm;
  border-radius: $input-border-radius;
  -webkit-border-radius: $input-border-radius;
  border: $input-border-width solid $input-border-color;
  background-image: url('../img/icons/select-icon.svg');
  background-position: 90% center;
  background-repeat: no-repeat;
  background-size: 1rem;
}

.widget-checkbox,
.widget-radio,
.widget-select,
.widget-upload {
  margin-bottom: $base-spacing-unit;

  legend {
    font-weight: 700;
  }
}

.widget-upload {
  label {
    display: block;
  }
}

.checkbox_container > span,
.radio_container > span {
  display: inline-flex;
  align-items: center;
}

// Mandatory & Error-Styling
// asterisk at mandatory fields
span.mandatory {
  color: $color-brand;
}

// error-text
p.error {
  margin-bottom: 0;
}
